<template>
  <div class="chart" :id="id"></div>
</template>

<script>
import util from "@/helper/util.js";
import partten from "@/helper/partten.js";
import * as echarts from "echarts";

export default {
  name: "multiple-bar-chart",
  componentName: "multiple-bar-chart",
  props: {
    width: {
      type: String,
      default: "100%",
    },
    height: {
      type: String,
      default: "13.889vh",
    },
    // 传入数据
    list: {
      type: Array,
      default: () => [
        {
          title: "日发电量",
          yAxisIndex: 0,
          value: [
            {
              text: "1日",
              value: 1,
            },
            {
              text: "2日",
              value: 2,
            },
            {
              text: "3日",
              value: 1,
            },
            {
              text: "4日",
              value: 3,
            },
            {
              text: "5日",
              value: 3,
            },
            {
              text: "6日",
              value: 3,
            },
            {
              text: "7日",
              value: 3,
            },
          ],
        },
        {
          title: "上网电量",
          yAxisIndex: 0,
          value: [
            {
              text: "1日",
              value: 1,
            },
            {
              text: "2日",
              value: 2,
            },
            {
              text: "3日",
              value: 1,
            },
            {
              text: "4日",
              value: 3,
            },
            {
              text: "5日",
              value: 3,
            },
            {
              text: "6日",
              value: 3,
            },
            {
              text: "7日",
              value: 3,
            },
          ],
        },
        {
          title: "购网电量",
          yAxisIndex: 0,
          value: [
            {
              text: "1日",
              value: 1,
            },
            {
              text: "2日",
              value: 2,
            },
            {
              text: "3日",
              value: 1,
            },
            {
              text: "4日",
              value: 3,
            },
            {
              text: "5日",
              value: 3,
            },
            {
              text: "6日",
              value: 3,
            },
            {
              text: "7日",
              value: 3,
            },
          ],
        },
        {
          title: "风速",
          yAxisIndex: 1,
          value: [
            {
              text: "1日",
              value: 1,
            },
            {
              text: "2日",
              value: 2,
            },
            {
              text: "3日",
              value: 1,
            },
            {
              text: "4日",
              value: 3,
            },
            {
              text: "5日",
              value: 3,
            },
            {
              text: "6日",
              value: 3,
            },
            {
              text: "7日",
              value: 3,
            },
          ],
        },
      ],
    },
    // 单位
    units: {
      type: Array,
      default: () => ["(万KWh)", "(风速)"],
    },
  },
  data () {
    return {
      id: "",
      chart: null,
      color: ["#05bb4c", "#4b55ae", "#fa8c16", "#f8de5b"],
    };
  },
  computed: {
    datas () {
      return this.list.map((t) => {
        return t.value;
      });
    },
    xdata () {
      return this.list[0].value.map((t) => {
        return t.text;
      });
    },
    ydata () {
      let result = [];
      this.units.forEach((value, index) => {
        let data = null;
        if (index == 0) {
          data = {
            type: "value",
            name: value,
            axisLabel: {
              formatter: "{value} ",
              fontSize: util.vh(14),
            },
            //分格线
            splitLine: {
              lineStyle: {
                color: "#999",
                type: "dashed",
              },
            },
          };
        } else {
          data = {
            type: "value",
            name: value,
            axisLabel: {
              formatter: "{value}",
              fontSize: util.vh(14),
            },
            //分格线
            splitLine: {
              show: false,
            },
          };
        }

        result.push(data);
      });

      return result;
    },
    series () {
      let result = [];
      this.list.forEach((value, index) => {
        result.push({
          name: value.title,
          type: "bar",
          yAxisIndex: value.yAxisIndex,
          data: value.value.map((t) => {
            return t.value;
          }),
        });
      });

      return result;
    },
  },
  methods: {
    initChart () {
      let option = {
        color: this.color,
        tooltip: {
          trigger: "item",
          backgroundColor: "rgba(0,0,0,0.3)",
          textStyle: {
            color: "#fff",
            fontSize: util.vh(16),
          },
          formatter: function (param) {
            return param.name + "<br >" + param.marker + param.seriesName + "：" + param.value;
          },
        },
        grid: {
          top: util.vh(32),
          left: util.vh(40),
          right: this.ydata.length > 1 ? util.vh(40) : util.vh(16),
          bottom: util.vh(24),
        },
        xAxis: [
          {
            type: "category",
            data: this.xdata,
            axisPointer: {
              type: "shadow",
            },
            axisLabel: {
              fontSize: util.vh(14),
            },
          },
        ],
        yAxis: this.ydata,
        series: this.series,
      };

      this.chart.setOption(option);
    },
  },
  created () {
    this.$nextTick(() => {
      this.id = "pie-chart-" + util.newGUID();
    });
  },
  mounted () {
    this.$nextTick(() => {
      this.$el.style.width = this.width;
      this.$el.style.height = this.height;
      this.chart = echarts.init(this.$el);
      this.initChart();
    });

  },
  updated () {
    this.$nextTick(() => {
      this.initChart();
    });
  },
};
</script>

<style lang="less">
.chart {
  width: 100%;
  height: 100%;
  display: inline-block;
}
</style>
